IMPLEMENTATION MODULE AsciiTime;

  (*-----------------------------------------------------------------------*)
  (* Letzte Bearbeitung                                                    *)
  (*                                                                       *)
  (*   11.06.2015: Erstellen der 1. Version                                *)
  (*                                                                       *)
  (* This Module is based on work provided by Gardens Point Modula-2       *)
  (* (c) Copyright 1996 Faculty of Information Technology                  *)
  (* Queensland University of Technology                                   *)
  (*-----------------------------------------------------------------------*)

  (* $Id: AsciiTime.mod,v 1.1 2015/09/13 20:48:41 mriedl Exp mriedl $ *)

FROM SysClock IMPORT DateTime;
              IMPORT StringsLib;

PROCEDURE Insert(VAR buff : ARRAY OF CHAR; 
                     valu : CARDINAL;
                     rIdx : INTEGER);
BEGIN
      WHILE valu > 0 DO
        buff[rIdx] := CHR(valu MOD 10 + ORD('0'));
        valu := valu DIV 10;
        DEC(rIdx);
      END;
END Insert;

PROCEDURE DateStr(VAR str  : ARRAY OF CHAR; 
                      time : DateTime;
                      rev  : BOOLEAN);

          VAR buff : ARRAY [0 .. 15] OF CHAR;
BEGIN
      IF NOT rev THEN
        buff := "0000:00:00";
        (* ===== 01234567890 *)
        Insert(buff, time.year,    3);
        Insert(buff, time.month,   6);
        Insert(buff, time.day,     9);
      ELSE
        buff := "00:00:0000";
        (* ===== 01234567890 *)
        Insert(buff, time.day,     1);
        Insert(buff, time.month,   4);
        Insert(buff, time.year,    9);
      END;
      StringsLib.Copy(str,buff);
END DateStr;

PROCEDURE TimeStr(VAR str  : ARRAY OF CHAR; 
                      time : DateTime);

          VAR buff : ARRAY [0 .. 15] OF CHAR;
BEGIN
      buff := "00:00:00";
      (* ===== 01234567 *)
      Insert(buff, time.hour,   1);
      Insert(buff, time.minute, 4);
      Insert(buff, time.second, 7);
      StringsLib.Copy(str,buff);
END TimeStr;

END AsciiTime. 
