IMPLEMENTATION MODULE SFormAus;

  (*========================================================================*)
  (* WICHTIG: BITTE NUR DIE DATEI XFormAus.mod.m2pp EDITIEREN !!!           *)
  (*========================================================================*)
  (*                                                                        *)
  (* Prozeduren zur Ausgabe von N Parametern (dWriteN) auf einen Stream     *)
  (* -------------------------------------------------------------------    *)
  (*                                                                        *)
  (* Letzte Bearbeitung:                                                    *)
  (*                                                                        *)
  (* 05.09.94, MRi: Durchsicht von FormAus                                  *)
  (* 02.08.95, MRi: Durchsicht von SFormAus                                 *)
  (* 22.06.15, MRi: Einf"uhren des "An"-Formats in WriteN,dWriteN           *)
  (* 02.10.16, MRi: Aufsplitten der Module FormAus und SFormAus in          *)
  (*                TFormAus,FFormAus,SFormAus                              *)
  (* 04.01.18, MRi: Erstellen eines einheitlichen Basismodules fuer den     *)
  (*                Praeprozessoer m2pp                                     *)
  (*                Hinzufuegen von {d}Write6                               *)
  (* 05.01.18, MRi: Hinzufuegen der Routinen {d}Write7 und SetExpAnz        *)
  (*------------------------------------------------------------------------*)
  (* Offene Punkte                                                          *)
  (*                                                                        *)
  (* - Eventuell die Formatanweisung ausgeben wenn eine ByteToXXX Routinen  *)
  (*   einen Fehler meldet so dass diese leichter gefunden werden kann.     *)
  (* - Durchsicht der Laengenparameter fuer Cardinal                        *)
  (* - Ausschreiben einer LONGINT wie LONGCARD behandeln                    *)
  (* - Ausschreiben von REAL einfuegen - Mechanismus wie bei CARDINAL       *)
  (*------------------------------------------------------------------------*)
  (* Licence : GNU Lesser General Public License (LGPL)                     *)
  (*------------------------------------------------------------------------*)      
  (* $Id: XFormAus.mod.m2pp,v 1.1 2018/01/05 13:41:44 mriedl Exp mriedl $ *)

FROM SYSTEM     IMPORT BYTE,TSIZE,ADR;
FROM ConvTypes  IMPORT ConvResults;
FROM Errors     IMPORT Fehler,Fehlerflag,ErrOut;
                IMPORT Errors;
FROM Streams    IMPORT Stream;
                IMPORT SIO;
FROM StringsLib IMPORT Copy,Concat;
FROM Deklera    IMPORT STRING;
FROM NumConvert IMPORT StringToCard,StringToInt;
                IMPORT TIO;
FROM FormAusLib IMPORT WrByteStr,ByteToInt,ByteToCard,
                       ByteToLngCard,ByteToLngReal,StrPrt;

PROCEDURE SetExpAnz(nExp : CARDINAL);

BEGIN
      IF (nExp < 1) OR (nExp > 4) THEN nExp:=4; END;
      SIO.ExpAnz:=nExp;
END SetExpAnz;

PROCEDURE dWrByteStr(VAR Aus    : Stream; (* F"ur Mocka *)
                         Str    : ARRAY OF BYTE;
                         Laenge : CARDINAL);

          VAR String : StrPrt;
BEGIN
      String:=ADR(Str);
      IF (Laenge > TSIZE(STRING)) THEN 
        ErrOut("Zeichenkette zu lang (SFormAus.ByteToStr) !");
        Laenge:=TSIZE(STRING) - 1; 
      END;
      String^[Laenge]:=0C;
      SIO.WrStr(Aus,String^);
END dWrByteStr;

PROCEDURE dWrByteStrN(VAR Aus    : Stream; (* F"ur Mocka *)
                          Str    : ARRAY OF BYTE; (* F"ur Mocka *)
                          Laenge : CARDINAL);

          VAR String : StrPrt;
BEGIN
      String:=ADR(Str);
      IF (Laenge > TSIZE(STRING)) THEN 
        ErrOut("Zeichenkette zu lang (FormAusLib.ByteToStr) !");
        Laenge:=TSIZE(STRING) - 1; 
      END;
      String^[Laenge]:=0C;
      SIO.WrStrForm(Aus,String^,-VAL(INTEGER,Laenge));
END dWrByteStrN;


CONST     max       = 7; (* Maximalzahl der Parameter *)

TYPE      ByteFeld  = ARRAY [1..max] OF ARRAY [0..255] OF BYTE;

VAR       Parameter : ByteFeld;
          Laengen   : ARRAY [1..max] OF CARDINAL;
          FFlag     : ARRAY [strAllRight..strEmpty] OF ARRAY [0..31] OF CHAR;

PROCEDURE dWriteN(VAR Aus    : Stream;
                      Format : ARRAY OF CHAR;
                      Anzahl : CARDINAL);

          (*----------------------------------------------------------------*)
          (* Schreibt Anzahl Parameter nach Format in die Datei Aus.        *)
          (*----------------------------------------------------------------*)

          CONST debug       = FALSE; (* Ausschreiben auf dem Bildschirm ? *)

          VAR   Int         : INTEGER;
                Card        : CARDINAL;
                LngCard     : LONGCARD;
                X           : LONGREAL;
                ZahlStr     : STRING;
                i,k,l,n,Par : CARDINAL;
                m           : INTEGER;
                result      : ConvResults;
                gesperrt    : BOOLEAN;
                LFormat     : STRING; (* Lokale Kopie des Format-StringsLib. *)

BEGIN
      Copy(LFormat,Format); (* Wegen m"oglicherweise fehlendem 0C *)
      i:=0; Par:=1; gesperrt:=FALSE; Fehler:=FALSE;
      WHILE (LFormat[i] # 0C) DO
        CASE CAP(LFormat[i]) OF
          '/' : SIO.WrLn(Aus); INC(i);
                IF debug THEN TIO.WrLn; END;
         |'X' : IF (LFormat[i+1] = ',') OR (LFormat[i+1] = 0C) THEN
                  SIO.WrChar(Aus,' '); INC(i);
                  IF debug THEN TIO.WrChar(' '); END;
                ELSE
                  INC(i); k:=0;
                  WHILE (LFormat[i] # ',') AND (LFormat[i] # 0C) DO
                    ZahlStr[k]:=LFormat[i];
                    INC(i); INC(k);
                  END;
                  ZahlStr[k]:=0C;
                  StringToCard(ZahlStr,k,result);
                  IF (result = strAllRight) THEN
                    FOR l:=1 TO k DO 
                      SIO.WrChar(Aus,' '); 
                      IF debug THEN TIO.WrChar(' '); END;
                    END;
                  END;
                END;|
          'A' : INC(i);
                IF NOT gesperrt THEN
  
                  IF (LFormat[i] = ',') OR (LFormat[i] = 0C) THEN
                    (* "A" wird wird wie "S" behandelt *)
                    dWrByteStr(Aus,Parameter[Par],Laengen[Par]); INC(Par); 
                  ELSE
                    (* "An" wurde angegeben *)
                    k:=0;
                    WHILE (LFormat[i] # ',') AND (LFormat[i] # 0C) DO
                      ZahlStr[k]:=LFormat[i];
                      INC(i); INC(k);
                    END;
                    ZahlStr[k]:=0C;
                    StringToCard(ZahlStr,n,result);
                    IF (result # strAllRight) THEN
                      Concat(Fehlerflag,FFlag[result],
                        " (SFormAus.dWriteN) (A?) !");
                      ErrOut(Fehlerflag); n:=3;
                    END;
(* Nochmal pruefen *)
                    dWrByteStrN(Aus,Parameter[Par],n); 
                    INC(Par); 
                  END;

                ELSE
                  ErrOut('Fehler bei String-Ausgabe (WriteN).');
                  Fehler:=TRUE;
                  RETURN;
                END;

                IF (Par > Anzahl) THEN gesperrt:=TRUE; END; |
          'S' : INC(i);
                IF NOT gesperrt THEN
                  dWrByteStr(Aus,Parameter[Par],Laengen[Par]); INC(Par);   
                  IF debug THEN WrByteStr(Parameter[Par],Laengen[Par]); END;
                ELSE
                  ErrOut('Fehler bei String-Ausgabe (dWriteN).');
                  Fehler:=TRUE;
                  RETURN;
                END;
                IF (Par > Anzahl) THEN gesperrt:=TRUE; END; |
          'F' : INC(i); k:=0;
                WHILE (LFormat[i] # '.') DO
                  ZahlStr[k]:=LFormat[i];
                  INC(i); INC(k);
                END;
                ZahlStr[k]:=0C;
                StringToCard(ZahlStr,n,result);
                IF (result # strAllRight) THEN
                  Concat(Fehlerflag,FFlag[result]," (SFormAus.dWriteN) (F?.m) !");
                  ErrOut(Fehlerflag); n:=12;
                END;
                INC(i); k:=0;
                WHILE (LFormat[i] # ',') AND (LFormat[i] # 0C) DO
                  ZahlStr[k]:=LFormat[i];
                  INC(i); INC(k);
                END;
                ZahlStr[k]:=0C;
                StringToInt(ZahlStr,m,result);
                IF (result # strAllRight) THEN
                  Concat(Fehlerflag,FFlag[result]," (SFormAus.dWriteN) (Fn.?) !");
                  ErrOut(Fehlerflag); m:=6;
                END;
                IF NOT gesperrt THEN
                  X:=ByteToLngReal(Parameter[Par],Laengen[Par]); INC(Par);
                  SIO.WrLngReal(Aus,X,n,m);
                  IF debug THEN TIO.WrLngReal(X,n,m); END;
                ELSE
                  ErrOut('Fehler bei Flie\3komma-Ausgabe (dWriteN).');
                  Fehler:=TRUE;
                  RETURN;
                END;
                IF (Par > Anzahl) THEN gesperrt:=TRUE; END; |
          'E' : INC(i); k:=0;
                WHILE (LFormat[i] # '.') DO
                  ZahlStr[k]:=LFormat[i];
                  INC(i); INC(k);
                END;
                ZahlStr[k]:=0C;
                StringToCard(ZahlStr,n,result);
                IF (result # strAllRight) THEN
                  Concat(Fehlerflag,FFlag[result]," (SFormAus.dWriteN) (E?.m) !");
                  ErrOut(Fehlerflag); n:=20;
                END;
                INC(i); k:=0;
                WHILE (LFormat[i] # ',') AND (LFormat[i] # 0C) DO
                  ZahlStr[k]:=LFormat[i];
                  INC(i); INC(k);
                END;
                ZahlStr[k]:=0C;
                StringToInt(ZahlStr,m,result);
                IF (result # strAllRight) THEN
                  Concat(Fehlerflag,FFlag[result]," (SFormAus.dWriteN) (En.?) !");
                  ErrOut(Fehlerflag); m:=8;
                END;
                IF NOT gesperrt THEN
                  X:=ByteToLngReal(Parameter[Par],Laengen[Par]); INC(Par);
                  SIO.WrLngReal(Aus,X,n,-m);
                  IF debug THEN TIO.WrLngReal(X,n,-m); END;
                ELSE
                  ErrOut('Fehler bei Festkomma-Ausgabe (dWriteN).');
                  Fehler:=TRUE;
                  RETURN;
                END;
                IF (Par > Anzahl) THEN gesperrt:=TRUE; END; |
          'I' : INC(i); k:=0;
                WHILE (LFormat[i] # ',') AND (LFormat[i] # 0C) DO
                  ZahlStr[k]:=LFormat[i];
                  INC(i); INC(k);
                END;
                ZahlStr[k]:=0C;
                StringToCard(ZahlStr,n,result);
                IF (result # strAllRight) THEN
                  Concat(Fehlerflag,FFlag[result]," (SFormAus.dWriteN) (I?) !");
                  ErrOut(Fehlerflag); n:=3;
                END;
                IF NOT gesperrt THEN
                  Int:=ByteToInt(Parameter[Par],Laengen[Par]); INC(Par);
                  SIO.WrInt(Aus,Int,n);
                  IF debug THEN TIO.WrInt(Int,n); END;
                ELSE
                  ErrOut('Fehler bei INTEGER-Ausgabe (dWriteN).');
                  Fehler:=TRUE;
                  RETURN;
                END;
                IF (Par > Anzahl) THEN gesperrt:=TRUE; END; |
          'C' : INC(i); k:=0;
                WHILE (LFormat[i] # ',') AND (LFormat[i] # 0C) DO
                  ZahlStr[k]:=LFormat[i];
                  INC(i); INC(k);
                END;
                ZahlStr[k]:=0C;
                StringToCard(ZahlStr,n,result);
                IF (result # strAllRight) THEN
                  Concat(Fehlerflag,FFlag[result]," (SFormAus.dWriteN) (C?) !");
                  ErrOut(Fehlerflag); n:=3;
                END;
                IF NOT gesperrt THEN
                  IF (Laengen[Par] = 2) THEN
                    Card:=ByteToCard(Parameter[Par],Laengen[Par]);
                    INC(Par); 
                    SIO.WrCard(Aus,Card,n);
                  ELSE (* LONGCARD - Argument *)
                    LngCard:=ByteToLngCard(Parameter[Par],Laengen[Par]);
                    INC(Par);
                    SIO.WrLngCard(Aus,LngCard,n);
                    IF debug THEN TIO.WrLngCard(LngCard,n); END;
                  END;
                ELSE
                  ErrOut('Fehler bei CARDINAL-Ausgabe (dWriteN).');
                  Fehler:=TRUE;
                  RETURN;
                END;
                IF (Par > Anzahl) THEN gesperrt:=TRUE; END; |
          ',' : INC(i);|
        ELSE
          Fehler:=TRUE;
          ErrOut('Falsches Format (dWriteN).');
          Errors.WriteString("Format : "); Errors.WriteString(LFormat); 
          Errors.WriteLn;
          RETURN;
        END;
      END;
END dWriteN;

  (*........................................................................*)

PROCEDURE dWrite1(VAR Aus    : Stream;
                      Format : ARRAY OF CHAR;
                      Par1   : ARRAY OF BYTE);

          VAR  i : CARDINAL;
BEGIN
      Fehler:=FALSE;
      Laengen[1]:=HIGH(Par1)+1;
      FOR i:=0 TO HIGH(Par1) DO Parameter[1,i]:=Par1[i]; END;
      dWriteN(Aus,Format,1);
      IF Fehler THEN ErrOut('Falsches Format (SFormAus.Write1)'); END;
END dWrite1;

  (*........................................................................*)

PROCEDURE dWrite2(VAR Aus    : Stream;
                      Format : ARRAY OF CHAR;
                      Par1   : ARRAY OF BYTE;
                      Par2   : ARRAY OF BYTE);

          VAR  i : CARDINAL;
BEGIN
      Fehler:=FALSE;
      Laengen[1]:=HIGH(Par1)+1; Laengen[2]:=HIGH(Par2)+1;
      FOR i:=0 TO HIGH(Par1) DO Parameter[1,i]:=Par1[i]; END;
      FOR i:=0 TO HIGH(Par2) DO Parameter[2,i]:=Par2[i]; END;
      dWriteN(Aus,Format,2);
      IF Fehler THEN ErrOut('Falsches Format (SFormAus.Write2)'); END;
END dWrite2;

  (*........................................................................*)

PROCEDURE dWrite3(VAR Aus    : Stream;
                      Format : ARRAY OF CHAR;
                      Par1   : ARRAY OF BYTE;
                      Par2   : ARRAY OF BYTE;
                      Par3   : ARRAY OF BYTE);

          VAR  i : CARDINAL;
BEGIN
      Fehler:=FALSE;
      Laengen[1]:=HIGH(Par1)+1; Laengen[2]:=HIGH(Par2)+1;
      Laengen[3]:=HIGH(Par3)+1;
      FOR i:=0 TO HIGH(Par1) DO Parameter[1,i]:=Par1[i]; END;
      FOR i:=0 TO HIGH(Par2) DO Parameter[2,i]:=Par2[i]; END;
      FOR i:=0 TO HIGH(Par3) DO Parameter[3,i]:=Par3[i]; END;
      dWriteN(Aus,Format,3);
      IF Fehler THEN ErrOut('Falsches Format (SFormAus.Write3)'); END;
END dWrite3;

  (*........................................................................*)

PROCEDURE dWrite4(VAR Aus    : Stream;
                      Format : ARRAY OF CHAR;
                      Par1   : ARRAY OF BYTE;
                      Par2   : ARRAY OF BYTE;
                      Par3   : ARRAY OF BYTE;
                      Par4   : ARRAY OF BYTE);

          VAR  i : CARDINAL;
BEGIN
      Fehler:=FALSE;
      Laengen[1]:=HIGH(Par1)+1; Laengen[2]:=HIGH(Par2)+1;
      Laengen[3]:=HIGH(Par3)+1; Laengen[4]:=HIGH(Par4)+1;
      FOR i:=0 TO HIGH(Par1) DO Parameter[1,i]:=Par1[i]; END;
      FOR i:=0 TO HIGH(Par2) DO Parameter[2,i]:=Par2[i]; END;
      FOR i:=0 TO HIGH(Par3) DO Parameter[3,i]:=Par3[i]; END;
      FOR i:=0 TO HIGH(Par4) DO Parameter[4,i]:=Par4[i]; END;
      dWriteN(Aus,Format,4);
      IF Fehler THEN ErrOut('Falsches Format (SFormAus.Write4)'); END;
END dWrite4;

  (*........................................................................*)

PROCEDURE dWrite5(VAR Aus    : Stream;
                      Format : ARRAY OF CHAR;
                      Par1   : ARRAY OF BYTE;
                      Par2   : ARRAY OF BYTE;
                      Par3   : ARRAY OF BYTE;
                      Par4   : ARRAY OF BYTE;
                      Par5   : ARRAY OF BYTE);

          VAR  i : CARDINAL;
BEGIN
      Fehler:=FALSE;
      Laengen[1]:=HIGH(Par1)+1; Laengen[2]:=HIGH(Par2)+1;
      Laengen[3]:=HIGH(Par3)+1; Laengen[4]:=HIGH(Par4)+1;
      Laengen[5]:=HIGH(Par5)+1;
      FOR i:=0 TO HIGH(Par1) DO Parameter[1,i]:=Par1[i]; END;
      FOR i:=0 TO HIGH(Par2) DO Parameter[2,i]:=Par2[i]; END;
      FOR i:=0 TO HIGH(Par3) DO Parameter[3,i]:=Par3[i]; END;
      FOR i:=0 TO HIGH(Par4) DO Parameter[4,i]:=Par4[i]; END;
      FOR i:=0 TO HIGH(Par5) DO Parameter[5,i]:=Par5[i]; END;
      dWriteN(Aus,Format,5);
      IF Fehler THEN ErrOut('Falsches Format (SFormAus.Write5)'); END;
END dWrite5;

  (*........................................................................*)

PROCEDURE dWrite6(VAR Aus    : Stream;
                      Format : ARRAY OF CHAR;
                      Par1   : ARRAY OF BYTE;
                      Par2   : ARRAY OF BYTE;
                      Par3   : ARRAY OF BYTE;
                      Par4   : ARRAY OF BYTE;
                      Par5   : ARRAY OF BYTE;
                      Par6   : ARRAY OF BYTE);

          VAR  i : CARDINAL;
BEGIN
      Fehler:=FALSE;
      Laengen[1]:=HIGH(Par1)+1; Laengen[2]:=HIGH(Par2)+1;
      Laengen[3]:=HIGH(Par3)+1; Laengen[4]:=HIGH(Par4)+1;
      Laengen[5]:=HIGH(Par5)+1; Laengen[6]:=HIGH(Par6)+1;
      FOR i:=0 TO HIGH(Par1) DO Parameter[1,i]:=Par1[i]; END;
      FOR i:=0 TO HIGH(Par2) DO Parameter[2,i]:=Par2[i]; END;
      FOR i:=0 TO HIGH(Par3) DO Parameter[3,i]:=Par3[i]; END;
      FOR i:=0 TO HIGH(Par4) DO Parameter[4,i]:=Par4[i]; END;
      FOR i:=0 TO HIGH(Par5) DO Parameter[5,i]:=Par5[i]; END;
      FOR i:=0 TO HIGH(Par6) DO Parameter[6,i]:=Par6[i]; END;
      dWriteN(Aus,Format,6);
      IF Fehler THEN ErrOut('Falsches Format (SFormAus.Write6)'); END;
END dWrite6;

  (*........................................................................*)

PROCEDURE dWrite7(VAR Aus    : Stream;
                      Format : ARRAY OF CHAR;
                      Par1   : ARRAY OF BYTE;
                      Par2   : ARRAY OF BYTE;
                      Par3   : ARRAY OF BYTE;
                      Par4   : ARRAY OF BYTE;
                      Par5   : ARRAY OF BYTE;
                      Par6   : ARRAY OF BYTE;
                      Par7   : ARRAY OF BYTE);

          VAR  i : CARDINAL;
BEGIN
      Fehler:=FALSE;
      Laengen[1]:=HIGH(Par1)+1; Laengen[2]:=HIGH(Par2)+1;
      Laengen[3]:=HIGH(Par3)+1; Laengen[4]:=HIGH(Par4)+1;
      Laengen[5]:=HIGH(Par5)+1; Laengen[6]:=HIGH(Par6)+1;
      Laengen[7]:=HIGH(Par7)+1;
      FOR i:=0 TO HIGH(Par1) DO Parameter[1,i]:=Par1[i]; END;
      FOR i:=0 TO HIGH(Par2) DO Parameter[2,i]:=Par2[i]; END;
      FOR i:=0 TO HIGH(Par3) DO Parameter[3,i]:=Par3[i]; END;
      FOR i:=0 TO HIGH(Par4) DO Parameter[4,i]:=Par4[i]; END;
      FOR i:=0 TO HIGH(Par5) DO Parameter[5,i]:=Par5[i]; END;
      FOR i:=0 TO HIGH(Par6) DO Parameter[6,i]:=Par6[i]; END;
      FOR i:=0 TO HIGH(Par7) DO Parameter[7,i]:=Par7[i]; END;
      dWriteN(Aus,Format,7);
      IF Fehler THEN ErrOut('Falsches Format (SFormAus.Write7)'); END;
END dWrite7;

BEGIN
      FFlag[strAllRight]    := 'In Ordnung !';
      FFlag[strOutOfRange]  := 'Wertebereichsueberschreitung !';
      FFlag[strWrongFormat] := 'Falsches Format !';
      FFlag[strEmpty]       := 'Zeichenkette leer !';
END SFormAus.
