IMPLEMENTATION MODULE StringsLib; (* M.Riedl, letzte Bearbeitung 14.11.1994 *)

  (*
   * $Id: StringsLib.mod,v 1.1 2015/09/13 20:48:42 mriedl Exp mriedl $
   *)

PROCEDURE Length(Str : ARRAY OF CHAR) : CARDINAL;

          VAR i : CARDINAL;
BEGIN
      i:=0;
      WHILE (Str[i] # 0C) DO
        IF (i = HIGH(Str)) THEN RETURN i+1; END;
        INC(i);
      END;
      RETURN i;
(*
 *    Str[HIGH(Str)+1]:=0C; (* Sicherheit ! *) 
 *    i:=0; WHILE (Str[i] # 0C) DO INC(i); END; RETURN i;
 *)      
END Length;

PROCEDURE Delete(VAR Str     : ARRAY OF CHAR;
                     pos,anz : CARDINAL);

          VAR  Len,i : CARDINAL;

BEGIN
      Len := Length(Str);
      IF (pos < Len) THEN
        IF (anz < Len - pos) THEN
          i := pos + anz;
          REPEAT
            Str[pos] := Str[i];
            INC(pos); INC(i);
          UNTIL i = Len;
        END;
        Str[pos] := 0C;
      END;
END Delete;

PROCEDURE Insert(VAR String : ARRAY OF CHAR;
                     SubStr : ARRAY OF CHAR;
                     pos    : CARDINAL);

          VAR  i,j,len1,len2 : CARDINAL;
BEGIN
      len1 := Length(String); len2 := Length(SubStr);
      j := len1;
      IF (j < pos) THEN pos := j; END;
      DEC(j,pos);
      FOR i:=j TO 0 BY -1 DO
        IF (i+pos+len2 < HIGH(String)) THEN
          String[i+pos+len2] := String[i+pos];
        END;
      END;
      i:=0;
      WHILE (i < len2) AND (pos + i < HIGH(String)) DO
        String[pos+i] := SubStr[i];
        INC(i);
      END;
END Insert;

PROCEDURE Append(VAR Str1 : ARRAY OF CHAR;
                     Str2 : ARRAY OF CHAR);

          VAR  i,j : CARDINAL;
BEGIN
      i := Length(Str1); j:=0; (* j <= HIGH in d. n"achsten Zeile wegen Mocka *)
      WHILE (i < HIGH(Str1)) AND (j <= HIGH(Str2)) AND (Str2[j] # 0C) DO
        Str1[i] := Str2[j];
        INC(i); INC(j);
      END;
      Str1[i]:=0C;
END Append;

PROCEDURE Copy(VAR Str1 : ARRAY OF CHAR;
                   Str2 : ARRAY OF CHAR);

          VAR i : CARDINAL;
BEGIN
      i:=0;
      WHILE (i <= HIGH(Str2)) AND (Str2[i] # 0C) AND (i < HIGH(Str1)) DO
        Str1[i]:=Str2[i]; INC(i);
      END;
      Str1[i]:=0C;
END Copy;

PROCEDURE Concat(VAR NStr      : ARRAY OF CHAR;
                     Str1,Str2 : ARRAY OF CHAR);

          VAR  i,j : CARDINAL;
BEGIN
      j:=0;
      WHILE (j < HIGH(NStr)) AND (j <= HIGH(Str1)) AND (Str1[j] # 0C) DO
        NStr[j] := Str1[j]; INC(j);
      END;

      i:=0;
      LOOP
        IF (j = HIGH(NStr)) THEN EXIT END;
        IF (i > HIGH(Str2)) THEN EXIT END;
        NStr[j] := Str2[i];
        IF (Str2[i] = 0C) THEN RETURN; END;
        INC(i); INC(j);
      END;
      NStr[j]:=0C; (* Falls Str2 nicht 0C-terminiert (Mocka) *)
END Concat;

PROCEDURE Pos(Str1,Str2 : ARRAY OF CHAR) : CARDINAL;

          VAR  i,j,k : CARDINAL;
BEGIN
      i:=0;
      LOOP
        IF (i > HIGH(Str1)) OR (Str1[i] = 0C) THEN RETURN MAX(CARDINAL) END;
        j:=0; k:=i;
        LOOP
          IF (j > HIGH(Str2)) OR (Str2[j] = 0C) THEN RETURN i END;
          IF (k > HIGH(Str1)) THEN RETURN MAX(CARDINAL); END;
          IF (Str1[k] # Str2[j]) THEN EXIT END;
          INC(j); INC(k);
        END;
        INC(i);
      END;
END Pos;

PROCEDURE Compare (str1, str2: ARRAY OF CHAR): CompareResults;

          VAR len1,len2,max,Index : CARDINAL;
BEGIN
      len1 := Length(str1); len2 := Length(str2);
      IF (len1 < len2) THEN max := len1; ELSE max := len2; END;
      Index:=0; 
      WHILE (str1[Index] = str2[Index]) AND (Index < max) DO INC(Index); END;
      IF (Index < max) THEN
        IF (str1[Index] < str2[Index]) THEN
          RETURN less;
        ELSE
          RETURN greater;
        END;
      ELSIF (len1 = len2) THEN (* Index = max *)
        RETURN equal;
      ELSIF (len1 < len2) THEN
        RETURN less;
      ELSE
        RETURN greater;
      END;
END Compare;

PROCEDURE Equal(str1, str2: ARRAY OF CHAR) : BOOLEAN;

          VAR  i,max,l1,l2 : CARDINAL;
               Gleich      : BOOLEAN;
BEGIN
      (*
        IF HIGH(str1) > HIGH(str2) THEN max:=HIGH(str1) ELSE max:=HIGH(str2) END;
      *)
      l1:=Length(str1); l2:=Length(str2);
      IF (l1 # l2) THEN RETURN FALSE; END;
      max:=l1;
      i:=0;
      REPEAT
        Gleich := str1[i] = str2[i]; INC(i);
      UNTIL NOT Gleich OR (i >= max);
      RETURN Gleich;
END Equal;

END StringsLib.
